<?php


namespace Drupal\tcmb_json\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Cache\CacheableMetadata;
use Symfony\Component\HttpFoundation\JsonResponse;

/**
 * Class TcmbDataController
 * @package Drupal\tcmb_json\Controller
 */
class TcmbDataController extends ControllerBase {

  /**
   * Get TCMB data
   * @return mixed
   */
  public function getTcmbData() {
    $conn = \Drupal::database();
    $config = \Drupal::config('tcmb.settings');
    $records = $conn->select('tcmb', 't')
      ->fields('t', [
        'updated'
      ])
      ->range(0, 1)
      ->orderBy('updated', 'DESC')
      ->execute()
      ->fetchAssoc();
    $tcmb_currency_codes = $config->get('tcmb_currency_codes', []);
    $updated = date('Y-m-d', strtotime($records['updated']));
    $records = $conn->select('tcmb', 't')
      ->fields('t', [
        'currency_name',
        'currency_code',
        'updated',
        'buying',
        'selling'
      ])
      ->condition('currency_code', $tcmb_currency_codes, 'IN')
      ->condition('updated', $updated)
      ->groupBy('currency_code')
      ->groupBy('currency_name')
      ->groupBy('updated')
      ->groupBy('buying')
      ->groupBy('selling');
    return new JsonResponse($records->execute()->fetchAll(\PDO::FETCH_ASSOC));
  }

}
